package info.textgrid.middleware;

import org.elasticsearch.action.get.GetRequestBuilder;
import org.elasticsearch.action.get.GetResponse;
import info.textgrid.middleware.oaipmh.ListMetadataFormatsType;
import info.textgrid.middleware.oaipmh.MetadataFormatType;
import info.textgrid.middleware.oaipmh.RequestType;

/**
 *
 */
public class MetadataFormatListDeliverer {

  private boolean idExist = true;

  /**
   * 
   */
  public MetadataFormatListDeliverer() {
    //
  }

  /**
   * @param id
   * @return
   */
  public ListMetadataFormatsType setMetadataFormatList(String id) {

    ListMetadataFormatsType lmft = new ListMetadataFormatsType();
    MetadataFormatType mft = new MetadataFormatType();

    GetRequestBuilder recordById = OAI_ESClient.getOaiESClient().prepareGet()
        .setIndex(OAI_ESClient.getEsIndex())
        .setType(OAI_ESClient.getEsType())
        .setFields(TGConstants.URI)
        .setId(id);

    GetResponse tgObject = recordById.execute().actionGet();

    if (tgObject.isExists()) {
      setIdExist(true);
      mft.setMetadataPrefix(TGConstants.METADATA_DC_PREFIX);
      mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
      mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);
      lmft.getMetadataFormat().add(mft);
    } else {
      setIdExist(false);
      lmft = null;
    }

    return lmft;
  }

  /**
   * @return
   */
  public ListMetadataFormatsType setMetadataFormatListWithoutId() {

    ListMetadataFormatsType lmft = new ListMetadataFormatsType();
    MetadataFormatType mft = new MetadataFormatType();
    MetadataFormatType mftIdiomMets = new MetadataFormatType();

    mft.setMetadataPrefix(TGConstants.METADATA_DC_PREFIX);
    mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
    mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);
    lmft.getMetadataFormat().add(mft);

    mftIdiomMets.setMetadataPrefix(TGConstants.METADATA_IDIOM_PREFIX);
    mftIdiomMets.setMetadataNamespace(OAIPMHUtilities.METS_NAMESPACE);
    mftIdiomMets.setSchema(OAIPMHUtilities.METS_SCHEMA_LOCATION);
    lmft.getMetadataFormat().add(mftIdiomMets);

    return lmft;
  }

  /**
   * @param request
   * @return
   */
  public boolean requestChecker(RequestType request) {

    boolean requestCheck = true;

    if (request.getFrom() != null ||
        request.getMetadataPrefix() != null ||
        request.getResumptionToken() != null) {

      requestCheck = false;

    } else if (request.getSet() != null ||
        request.getUntil() != null) {
      requestCheck = false;
    }

    return requestCheck;
  }

  /**
   * @return
   */
  public boolean isIdExist() {
    return this.idExist;
  }

  /**
   * @param idExist
   */
  public void setIdExist(boolean idExist) {
    this.idExist = idExist;
  }

}
